// STOPP - den Zensurwahn!
// JavaScript-Overlay
// Veröffentlicht unter GPL v2
// Grafik und Script: Markus Schmidt
// JQuery erforderlich:
// Copyright (c) 2008 John Resig (jquery.com)
// Dual licensed under the MIT (MIT-LICENSE.txt)
// and GPL (GPL-LICENSE.txt) licenses.

// -------------
// Konfiguration
// -------------

// URL auf die Seite, die beim Klick auf "Information" aufgerufen wird
stoppInformation="http://www.spiegel.de/netzwelt/web/0,1518,619509,00.html";

// Bild des Overlays
stoppImage="/images/stopp.gif";

// Position und Größe, wenn ausgeblendet
offWidth=48;
offHeight=48;
offX=10;
offY=-14;
offXPerc=false;	// ist dieser Wert wahr, ist der Wert bei offX prozentual,
				//wobei 50 das Objekt zentriert und 100 rechtsbündig bedeutet.
offYPerc=false;	// ist dieser Wert wahr, ist der Wert bei offY prozentual,
				//wobei 50 das Objekt zentriert und 100 den unteren Bildrand bezeichnet.

// Position und Größe, wenn eingeblendet
onWidth=480;
onHeight=480;
onX=50;
onY=50;
onXPerc=true;	// ist dieser Wert wahr, ist der Wert bei offX prozentual,
				//wobei 50 das Objekt zentriert und 100 rechtsbündig bedeutet.
onYPerc=true;	// ist dieser Wert wahr, ist der Wert bei offY prozentual,
				//wobei 50 das Objekt zentriert und 100 den unteren Bildrand bezeichnet.

stoppInfoButton = [145, 432, 245, 450]; // Koordinaten des Info-Buttons
stoppCloseButton = [255, 432, 330, 450]; // Koordinaten des Schließen-Buttons

// der HTML-Code, der in die Seite eingefügt wird
stoppTemplate = '<img id="stoppImage" src="' + stoppImage + '"\
 alt="STOPP - den Zensurwahn!" usemap="#stoppMap" />\
<map name="stoppMap" id="stoppMap">\
<area shape="rect" coords="' + stoppInfoButton.join(",") + '" href="' + stoppInformation + '"\
 title="Weitere Informationen..." target="_blank" />\
<area shape="rect" coords="' + stoppCloseButton.join(",") + '" href="" onClick="stoppPopOut();\
 return false;" title="Ausblenden" />\
<area shape="rect" coords="0,0,' + onWidth + ',' + stoppInfoButton[1] + '" onClick="stoppPopIn();\
 return false;" title="Ausblenden" class="stoppOpen" />\
<area shape="rect" coords="0,' + stoppInfoButton[3] + ',' + onWidth + ',' + onHeight + '" onClick="stoppPopIn();\
 return false;" title="Ausblenden" class="stoppOpen" />\
</map>';

// Das CSS-Design
stoppCSS = {
	"position": "absolute",
	"z-index": 1000,
	"display": "block",
	"border-width": 0
}
mapCSS = {
	"border-width": "0px"
}
// Wie lange soll der Cookie gespeichert werden?
stoppCookieExpires = 1000*60*60*24*31

//soll der Cookie überhaupt gespeichert werden?
stoppUseCookie = true;

// ----
// Code
// ----
var _COOKIE = new Object;
if(stoppUseCookie) {
	_COOKIE = stoppReadCookie();
}
$(document).ready(function () {
	$("body, html").css({
		"width": "100%",
		"height": "100%"
	});
	$("area").css({
		"outline-color": "-moz-use-text-color",
		"outline-style": "none",
		"outline-width": 0,
		"border": "2px solid blue"
	});
	$("area").css({"cursor": "pointer" });
	$("body").append(stoppTemplate);
	stoppReset();
	$("#stoppMap").css(mapCSS);
	if(_COOKIE["stoppSeen"] !== undefined) {
		
	} else {
		stoppPopIn();
		_COOKIE["stoppSeen"] = "true";
		if(stoppUseCookie) {
			stoppWriteCookie();
		}
	}
});
function stoppReset() {
	var size = stoppWindowSize();
	var left = (offXPerc) ? stoppPerc2Pix(size.width, offX, offWidth) : offX;
	var top = (offYPerc) ? stoppPerc2Pix(size.height, offY, offHeight) : offY;
	$("#stoppImage").css({
		"width":	offWidth,
		"height":	offHeight,
		"left":		left,
		"top":		top
	});
	$("#stoppImage").css(stoppCSS);
}
function stoppPopIn() {
	var size = stoppWindowSize();
	var left = (onXPerc) ? stoppPerc2Pix(size.width, onX, onWidth) : onX;
	var top = (onYPerc) ? stoppPerc2Pix(size.height, onY, onHeight) : onY;
	$("#stoppImage").animate({
		"width":	onWidth,
		"height":	onHeight,
		"left":		left,
		"top":		top
	}, 1000);
	$("#stoppImage").css({"cursor": "default"});
	$(".stoppOpen").css({"cursor": "default"});
}
function stoppPopOut() {
	var size = stoppWindowSize();
	var left = (offXPerc) ? stoppPerc2Pix(size.width, offX, offWidth) : offX;
	var top = (offYPerc) ? stoppPerc2Pix(size.height, offY, offHeight) : offY;
	$("#stoppImage").animate({
		"width":	offWidth,
		"height":	offHeight,
		"left":		left,
		"top":		top
	}, callback=function() {
		$("#stoppImage").queue("fx", []);
		$("#stoppImage").stop();
	});
	$("#stoppImage").css({"cursor": "pointer"});
	$(".stoppOpen").css({"cursor": "pointer"});
}

// --------------------------
// Prozent in Pixel umrechnen
// --------------------------
function stoppPerc2Pix(G, p, a) {
	return G * (p / 100) - a * (p / 100);
}

// ------------
// Fenstergröße
// ------------
function stoppWindowSize() {
	var size = {width: 0, height: 0};
	if (document.documentElement) {
		size.width = document.documentElement.offsetWidth;
		size.height = document.documentElement.offsetHeight;
	} else if (window.innerWidth && window.innerHeight) {
		size.width = window.innerWidth;
		size.height = window.innerHeight;
	}
	return size;
}

// ---------------
// cookie handling
// ---------------
function stoppReadCookie() {
	var _cookie = new Object();
	var _cookiestr = document.cookie;
	if(_cookiestr){
		var _cookiearray = _cookiestr.split(";");
		for(var c=0, cl=_cookiearray.length; c<cl; c++) {
			var pair = _cookiearray[c].split("=");
			_cookie[stoppStrip(pair[0])] = stoppStrip(pair[1]);
		}
	}
	return _cookie;
}

function stoppSetCookie(name, val) {
	_COOKIE[name] = val;
	write_cookie();
}

function stoppWriteCookie() {
	var expires = new Date();
	expires.setTime(expires.getTime() + stoppCookieExpires);
	for(var c in _COOKIE) {
		if(c != "expires") {
			document.cookie = c + "=" + _COOKIE[c] + ";expires=" + expires;
		}
	}
}
function stoppStrip(str) {
	while(str.charAt(0) == " ") {
		str = str.slice(1, str.length);
	}
	while(str.charAt(str.length - 1) == " ") {
		str = str.slice(0, str.length - 1);
	}
	return str;
}
